import re
from sqlalchemy.ext.declarative import declared_attr, declarative_base


_camelcase_re = re.compile(r'([A-Z]+)(?=[a-z0-9])')


class __Base(object):

    @declared_attr
    def __tablename__(cls):
        return cls._camel_to_snake_case(cls.__name__)


    def _camel_to_snake_case(name):
        def _join(match):
            word = match.group()

            if len(word) > 1:
                return ('_%s_%s' % (word[:-1], word[-1])).lower()

            return '_' + word.lower()

        return _camelcase_re.sub(_join, name).lstrip('_')



EntityBase = declarative_base(cls=__Base)
