from ..di.ContextualService import ContextualService
from .OrmSessionFactory import OrmSessionFactory


class OrmSession(ContextualService):

    def __init__(self, session_factory: OrmSessionFactory):
        self._session = session_factory.create()


    def __getattr__(self, name):
        return getattr(self._session, name)


    def on_context_teardown(self):
        print('INFO [OrmSession] Closing session')
        self._session.close()
