from sqlalchemy import create_engine
from sqlalchemy.orm import sessionmaker
from ..config.ConfigProvider import ConfigProvider


class OrmSessionFactory:

    CONFIG_KEY = 'database'


    def __init__(self, config: ConfigProvider):
        connection_string = config.get_section(self.CONFIG_KEY)['connectionString']
        engine = create_engine(connection_string, max_overflow=30)
        self._Session = sessionmaker(bind=engine)


    def create(self):
        return self._Session()
