from datetime import datetime
from sqlalchemy import Column, Integer, Boolean, DateTime


class LifeCycleMixin:

    ACTIVE_FILTER = {
        'deleted_at': None,
        'is_active': True
    }


    id = Column(Integer, primary_key=True)
    is_active = Column(Boolean, nullable=False, default=True)
    created_at = Column(DateTime, nullable=False, default=datetime.utcnow)
    deleted_at = Column(DateTime)


    def delete(self):
        self.deleted_at = datetime.utcnow()
