import sentry_sdk
from sentry_sdk.integrations.sanic import SanicIntegration
from ..config.ConfigProvider import ConfigProvider


class SentryLogger:

    CONFIG_KEY = 'sentry'


    def __init__(self, config: ConfigProvider):
        dsn = config.get_section(self.CONFIG_KEY)['dsn']

        sentry_sdk.init(
            dsn=dsn,
            integrations=[SanicIntegration()],
            environment=config.env.value
        )
