from ..di.DiContainer import DiContainer
from .ContextualSchema import ContextualSchema


class ContextualSchemaFactory:

    def __init__(self, container: DiContainer):
        self._container = container


    def create(self, schema_cls: ContextualSchema, **kwargs) -> ContextualSchema:
        schema = self._container.create(schema_cls, **kwargs)
        schema.context[ContextualSchema.CONTEXT_KEY] = self._container
        return schema
