from sanic import Sanic
from ...database.mixins.LifeCycleMixin import LifeCycleMixin
from ..ContextualField import ContextualField


class LinkField(ContextualField):

    def __init__(self, view_name: str, *args, **kwargs):
        super().__init__(*args, attribute='id', dump_only=True, **kwargs)
        self._view_name = view_name


    def _serialize(self, value, attr, obj: LifeCycleMixin, **kwargs):
        container = self.get_context()
        sanic = container.get(Sanic)

        link = sanic.url_for(view_name=self._view_name, id=obj.id)
        return link
