from typing import Union
from sanic import Sanic
from sanic.views import HTTPMethodView
from ..di.DiContainer import DiContainer


class Router:

    def __init__(self, app: Sanic, container: DiContainer):
        self._app = app
        self._container = container


    def route(self, view: HTTPMethodView, route: str):
        # class_params = self._container.get_class_params(view)
        # inject = map(lambda cls: self._container.get(cls), class_params)
        # self._app.add_route(view.as_view(*inject), route)
        self._app.add_route(view.as_view(self._container), route)


    def url_for(self, view: Union[str, type, HTTPMethodView], **kwargs) -> str:
        if isinstance(view, HTTPMethodView):
            view_class_name = type(view).__name__
        elif isinstance(view, str):
            view_class_name = view
        else:
            view_class_name = view.__name__

        return self._app.url_for(view_class_name, **kwargs)
