from sanic_session import Session as SanicSession, InMemorySessionInterface
from sanic import Sanic
from sanic.request import Request
from ..config.ConfigProvider import ConfigProvider


class Session:

    CONFIG_KEY = 'session'

    # POZOR: tohle se nikdy nesmi zavolat vickrat, takze musi byt jen jedna instance
    # kazdy call prida jeden middleware handler
    def __init__(self, sanic: Sanic, config_provider: ConfigProvider):
        self._sanic = sanic
        self._config = config_provider.get_section(self.CONFIG_KEY)
        self._session = None

        # interface = InMemorySessionInterface()

        # if config and config.get('redis'):
        #     redis_config = config.get('redis')
        #     redis = await aioredis.create_redis_pool(redis_config['address'], db=redis_config['db'])
        #     interface = AIORedisSessionInterface(redis)

        # self._session = SanicSession()

        # POZOR: tohle se nikdy nesmi zavolat vickrat, takze musi byt jen jedna instance
        # kazdy call prida jeden middleware handler
        # self._session.init_app(sanic, interface=interface)


    async def open(self, request: Request):
        session = await self._get_session()
        return await session.interface.open(request)


    async def _get_session(self) -> SanicSession:
        if self._session:
            return self._session

        interface = InMemorySessionInterface()

        # if self._config and self._config.get('redis'):
        #     redis_config = self._config.get('redis')
        #     redis = await aioredis.create_redis_pool(redis_config['address'], db=redis_config['db'])
        #     interface = AIORedisSessionInterface(redis)

        self._session = SanicSession()

        # POZOR: tohle se nikdy nesmi zavolat vickrat, takze musi byt jen jedna instance
        # kazdy call prida jeden middleware handler
        self._session.init_app(self._sanic, interface=interface)
        return self._session
